
import { Component, OnInit, AfterViewInit, Output, Input, EventEmitter, ViewChild } from '@angular/core';
import { Subject, Unsubscribable } from 'rxjs';
import { ActivatedRoute, Router } from '@angular/router';
import { NzNotificationService } from 'ng-zorro-antd/notification';
import { Http } from '@global/http/http';
import { Util } from '@global/util/util';
import { AppEnvironment } from 'src/environments/AppEnvironment';


import { AppMenu } from '@widgets/app/app-index-view-appmenu/app-index-view-appmenu';


@Component({
  selector: 'view-app-index-view',
  templateUrl: './app-index-view.page.html',
  styleUrls: ['./app-index-view.page.less']
})
export class AppIndexViewPage implements OnInit, AfterViewInit {

    /**
     * 构造方法
     * @param {NzNotificationService} $notice
     * @memberof IndexPage
     */
    constructor(private $util: Util, private $router: Router, private $route: ActivatedRoute, private $notice: NzNotificationService) {}


    /**
     * 子组件AppMenu
     *
     * @public
     * @type {Subject}
     * @memberof AppIndexView
     */
    @ViewChild(AppMenu, {static: false})
    private appmenu: AppMenu;

	/**
	 * 视图标识
	 *
	 * @type {string}
	 * @memberof AppDashboardView
	 */
	public viewtag: string = 'E9352AA5-1F44-4BBA-B3A8-EBF95398B498';

    /**
     * 父数据对象
     *
     * @protected
     * @type {*}
     * @memberof AppIndexView
     */
    protected srfparentdata: any = {};

    /**
     * 视图订阅对象
     *
     * @public
     * @type {Subject}
     * @memberof AppIndexView
     */
    public viewState: Subject<ViewState> = new Subject();

    /**
     * 视图值变化事件
     *
     * @public
     * @type {EventEmitter}
     * @memberof AppIndexView
     */    
    @Output() public viewdataschange = new EventEmitter();

    /**
     * 视图参数
     *
     * @public
     * @type {Subject}
     * @memberof AppIndexView
     */
    @Input() public viewdata: any;


    /**
     * 视图加载完成事件
     *
     * @type {EventEmitter<any>}
     * @memberof AppIndexView
     */
    @Output() public viewloadEvent: EventEmitter<any> = new EventEmitter<any>();

    /**
     * 视图数据变化事件
     *
     * @type {EventEmitter<any>}
     * @memberof AppIndexView
     */
    @Output() public viewdataschangeEvent: EventEmitter<any> = new EventEmitter<any>();

    /**
     * 视图模型数据
     *
     * @type {*}
     * @memberof AppIndexView
     */
    public model: any = {
        srfTitle: '应用首页视图',
        srfCaption: '首页',
        srfSubCaption: '',
        dataInfo: ''
    };


    /**
     * 引擎初始化
     *
     * @private
     * @memberof AppIndexView
     */
    private engineInit(): void {
    }

    /**
     * angular生命周期
     *
     * @memberof AppIndexView
     */
    public ngOnInit() {

    }

     /**
     * angular生命周期(在ngOnInit之后)
     *
     * @memberof AppIndexView
     */
    public ngAfterViewInit() {
        this.engineInit();
        this.viewState.next({ tag: 'appmenu', action: 'load', data: {} });

    }




    /**
     * 收缩
     *
     * @type {boolean}
     * @memberof AppIndexView
     */
    public collapseChange: boolean = false;

}
